#ifndef __Mech_h__
#define __Mech_h__

#include "Vehicle.h"

class Mech: public Vehicle{
public:
	Mech();
	~Mech();

	virtual Vehicle* clone() const;
	virtual void reset();

	virtual void takeOverClientState( const Client::state_s& clientState );
	virtual void fillInClientState( Client::state_s& clientState ) const;

	virtual void processInput(Input::actionMap_t& actionMap, Input::mouseState_t& mouseState);

	virtual void prepareForSimulationStep();
	virtual void updateAfterSimulationStep();

	virtual bool collidedWithGameObject(const FVector3& contactPoint, GameObject* other, dContact& contact);
	virtual bool collidedWithTerrain(const FVector3& contactPoint, dContact& contact);

protected:
	float mainUnitYaw;
	float mainUnitPitch;

	bool standingOnFeet;
};

#endif // __Mech_h__
